package com.jeeplus.test.reimbursementProject.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.sys.service.dto.UserDTO;
import com.jeeplus.test.reimbursementProject.domain.dto.ProjectReimbursementUserDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author li-peike
 * @version 1.0.0
 * @ClassName ReimbursementSysMapper.java
 * @Description TODO
 * @createTime 2022年05月06日 10:40:00
 */
@Mapper
public interface ProjectReimbursementUserMapper extends BaseMapper<ProjectReimbursementUserDTO> {
    /**
     * 根据条件查询数据信息
     * @param page
     * @param reimbursementUser
     * @return
     */
    IPage<ProjectReimbursementUserDTO> findList(Page<ProjectReimbursementUserDTO> page, @Param("reimbursementUser")ProjectReimbursementUserDTO reimbursementUser);
    /**
     * 根据条件查询数据信息
     * @param page
     * @param reimbursementUser
     * @return
     */
    IPage<ProjectReimbursementUserDTO> getYearList(Page<ProjectReimbursementUserDTO> page, @Param("reimbursementUser")ProjectReimbursementUserDTO reimbursementUser);

    /**
     * 保存人员报销信息
     * @param reimbursementUser
     */
    void save(ProjectReimbursementUserDTO reimbursementUser);

    /**
     * 保存人员报销信息
     * @param reimbursementUserList
     */
    void saveList(@Param("reimbursementUserList")List<ProjectReimbursementUserDTO> reimbursementUserList);

    /**
     * 修改人员报销信息
     * @param reimbursementUser
     */
    void update(ProjectReimbursementUserDTO reimbursementUser);

    /**
     * 查询业务信息
     * @param id
     * @return
     */
    ProjectReimbursementUserDTO queryById(String id);

    /**
     * 查询报销信息(根据人员id和年份)
     * @param reimbursementUser
     * @return
     */
    ProjectReimbursementUserDTO queryByUserIdAndYear(ProjectReimbursementUserDTO reimbursementUser);

    /**
     * 根据id删除人员报销信息（物理删除）
     * @param idList
     */
    void delete(@Param("idList") List<String> idList);

    /**
     * 根据部门和人员名称查询人员信息
     * @param reimbursementUserDTO
     * @return
     */
    List<UserDTO> getUserByNameAndOfficeName(ProjectReimbursementUserDTO reimbursementUserDTO);

    /**
     * 根据人员id集合和年份查询已存在的人员信息
     * @param userIdList
     * @param year
     * @return
     */
    List<ProjectReimbursementUserDTO> getExistReimbursementUserList(@Param("userIdList") List<String> userIdList, @Param("year") String year);

}
